<?php
/**
 * Plugin Name: Uncle2 CV2
 * Description:  给你的网站轻松实现谷歌consent V2，完美兼容GA4,GTM,谷歌广告
 * Plugin URI:  https://2uncle.com/2uncle-cv2/
 * Version:     1.0.1
 * Author:      2uncle
 * Author URI:  https://2uncle.com/
 * Text Domain: uncle2_cv2
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

function require_all_php($path) {
    foreach (glob("{$path}/*.php") as $filename) {
        require_once $filename;
    }
}

const VERSION = '1.0.1';
// Load the helper file to increase protection you can include some core functions of your plugin like innit() functions etc. in this file before you obfuscate it.
require 'includes/lb_helper.php';
require_once( __DIR__ . '/lib/csf/classes/setup.class.php' );
require_once( __DIR__ . '/backend/admin.php' );
require_once( __DIR__ . '/lib/base/uncle2.php');

// 添加设置链接
add_filter('plugin_action_links_' . plugin_basename(__FILE__), 'uncle2_cv2_plugin_action_links');


function uncle2_cv2_plugin_action_links($links) {
    $settings_link = '<a href="' . admin_url('admin.php?page=uncle2_cv2') . '">' . __('设置') . '</a>';
    array_unshift($links, $settings_link);
    return $links;
}



/**
 * Main Uncle2_CV2 Class
 *
 * The main class that initiates and runs the plugin.
 *
 * @since 1.0.0
 */
final class Uncle2_CV2 {

	

	/**
	 * Instance
	 *
	 * @since 1.0.0
	 *
	 * @access private
	 * @static
	 *
	 * @var Uncle2_CV2 The single instance of the class.
	 */
	private static $_instance = null;

	/**
	 * Instance
	 *
	 * Ensures only one instance of the class is loaded or can be loaded.
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 * @static
	 *
	 * @return Uncle2_CV2 An instance of the class.
	 */
	public static function instance() {

		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;

	}

	/**
	 * Constructor
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 */
	public function __construct() {

		add_action( 'plugins_loaded', [ $this, 'on_plugins_loaded' ] );

	}

	/**
	 * Load Textdomain
	 *
	 * Load plugin localization files.
	 *
	 * Fired by `init` action hook.
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 */
	public function i18n() {

		load_plugin_textdomain( 'uncle2_cv2' );

	}

	/**
	 * On Plugins Loaded
	 *
	 * Checks if Elementor has loaded, and performs some compatibility checks.
	 * If All checks pass, inits the plugin.
	 *
	 * Fired by `plugins_loaded` action hook.
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 */
	public function on_plugins_loaded() {

		
			add_action( 'elementor/init', [ $this, 'init' ] );
            
		

	}

	

	/**
	 * Initialize the plugin
	 *
	 * Load the plugin only after Elementor (and other plugins) are loaded.
	 * Load the files required to run the plugin.
	 *
	 * Fired by `plugins_loaded` action hook.
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 */
	public function init() {
	
		$this->i18n();

		// Add Plugin actions
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'init_widgets' ] );
		
        

        
	}

	/**
	 * Init Widgets
	 *
	 * Include widgets files and register them
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 */
	public function init_widgets() {

		// Include Widget files
		//require_once( __DIR__ . '/widgets/backtop-widget.php' );
		require_all_php(__DIR__ .'/widgets');
		

		// Register widget
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new \Elementor_BackTop_Widget() );
		

	}

	
	

}

Uncle2_CV2::instance();
